Page({

  blockApiList: [
    "navigateTo",
    "navigateBack",
    "reLaunch",
    "redirectTo",
    "switchTab",
    "showToast",
    "showLoading",
    "showActionSheet",
    "hideToast",
    "hideLoading",
    "showModal",
    "navigateToMiniProgram",
    "navigateBackMiniProgram"
  ],

  nopFunc:function () {

  },

  /**
   * 页面的初始数据
   */
  data: {
  
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    String.prototype.endsWith = String.prototype.endsWith || function (str) {
      if (str == null || str == "" || this.length == 0 || str.length > this.length) {
        return false;
      }
      if (this.substring(this.length - str.length)) {
        return true;
      } else {
        return false;
      }
      return true;
    };

    var currentPages = getCurrentPages();
    this.currentRoute = currentPages[currentPages.length - 1].route;
    (this.currentRoute[0] != '/') && (this.currentRoute = '/' + this.currentRoute)

    var that = this;
    this.blockApiList.forEach(function (api) {
      if (!wx["fetchSubPkg_" + api]) {
        Object.defineProperty(wx, "fetchSubPkg_" + api, { value: wx[api], configurable: true });
        Object.defineProperty(wx, api, { value: that.nopFunc });
      }
    });

    this.navigateTo = wx.fetchSubPkg_navigateTo || wx.navigateTo;
    this.reLaunch = wx.fetchSubPkg_reLaunch || wx.reLaunch;
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function (res) {
    if (wx.pagesToNavi) {
      this.doFetchSubPkg();
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function (res) {
    var that = this;
    setTimeout(function () {
      that.reLaunch({
        url: that.currentRoute
      })
    }, 200);
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
  
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
  
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
  
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
  
  },

  fetchSubPackages: function() {
    if (wx.fetchingSubPkg)
      return;
    wx.fetchingSubPkg = true;
    var that = this;
    var config = __wxConfig;
    if (config) {
      var subPackageConfig = config.subPackages;
      if (subPackageConfig) {
        var timeout = 300;
        var pagesToNavi = [];
        subPackageConfig.forEach(function(sp) {
          var root = sp.root;
          if (root) {
            root.endsWith('/') || (root = root + "/");
            var pages = sp.pages;
            if (pages.length > 0) {
              var naviPage = root + pages[0];
              (__wxConfig.pages.indexOf(naviPage) == -1) &&
                (pages[0].indexOf(root) == 0) &&
                (naviPage = pages[0]);
              naviPage = '/' + naviPage;
              (naviPage !== that.currentRoute) && (pagesToNavi.push(naviPage));
            }
          }
        });
        wx.pagesToNavi = pagesToNavi;
        this.doFetchSubPkg();
      }
    }
  },

  doFetchSubPkg: function() {
    var that = this;
    if (wx.pagesToNavi && wx.pagesToNavi.length > 0) {
      that.setData({
        tip: "正在自动下载子包， 剩余子包数：" + wx.pagesToNavi.length
      });
      var naviPage = wx.pagesToNavi.pop();
      setTimeout(function() {
        that.navigateTo({
          url: naviPage
        });
      }, 300)
    } else {
      that.onFetchSubPkgFinished();
    }
  },

  onFetchSubPkgFinished: function() {
    this.setData({
      tip: "自动下载子包完成，可以到调试页面点击pull按钮拉包了。"
    });

    delete wx.pagesToNavi;
    this.blockApiList.forEach(function (api) {
      if (wx["fetchSubPkg_" + api]) {
        Object.defineProperty(wx, api, { value: wx["fetchSubPkg_" + api] });
        delete wx["fetchSubPkg_" + api];
      }
    });
    wx.showToast({
      title: "hahaha"
    })
    console.log(getCurrentPages());
  }
})